;/*****************************************************************************
;**
;* FILE: 	Minimize on MMB.ahk
;* PRODUCT:	Tools
;* AUTHOR: 	Ingo Karkat <ingo@karkat.de>
;* DATE CREATED:16-Jun-2010
;*
;******************************************************************************
;* CONTENTS: 
;   Minimize the current window by middle-clicking on the window's title bar. 
;
;* REMARKS: 
;
;* SOURCE: 
;   MButton: Close windows(taskbar+titlebar) & open IE links
;   by evl in the AutoHotkey Community,
;   http://www.autohotkey.com/forum/topic8434.html
;
;* Copyright: (C) 2010 Ingo Karkat
;   This program is free software; you can redistribute it and/or modify it
;   under the terms of the GNU General Public License.
;   See http://www.gnu.org/copyleft/gpl.txt 
;
;* REVISION	DATE		REMARKS 
;   1.00.002	17-Jun-2010	Published. 
;	001	16-Jun-2010	file creation
;*****************************************************************************/
MButton:: 
  SetBatchLines, -1 
  CoordMode, Mouse, Screen 
  SetMouseDelay, -1 ; no pause after mouse clicks 
  SetKeyDelay, -1 ; no pause after keys sent 
  MouseGetPos, ClickX, ClickY, WindowUnderMouseID 
  WinActivate, ahk_id %WindowUnderMouseID% 

  ; WM_NCHITTEST 
  SendMessage, 0x84,, ( ClickY << 16 )|ClickX,, ahk_id %WindowUnderMouseID% 
  WM_NCHITTEST_Result =%ErrorLevel% 
      /* 
      #define HTERROR             (-2) 
      #define HTTRANSPARENT       (-1) 
      #define HTNOWHERE           0 
      #define HTCLIENT            1 
      #define HTCAPTION           2 
      #define HTSYSMENU           3 
      #define HTGROWBOX           4 
      #define HTSIZE              HTGROWBOX 
      #define HTMENU              5 
      #define HTHSCROLL           6 
      #define HTVSCROLL           7 
      #define HTMINBUTTON         8 
      #define HTMAXBUTTON         9 
      #define HTLEFT              10 
      #define HTRIGHT             11 
      #define HTTOP               12 
      #define HTTOPLEFT           13 
      #define HTTOPRIGHT          14 
      #define HTBOTTOM            15 
      #define HTBOTTOMLEFT        16 
      #define HTBOTTOMRIGHT       17 
      #define HTBORDER            18 
      #define HTREDUCE            HTMINBUTTON 
      #define HTZOOM              HTMAXBUTTON 
      #define HTSIZEFIRST         HTLEFT 
      #define HTSIZELAST          HTBOTTOMRIGHT 
      #if(WINVER >= 0x0400) 
      #define HTOBJECT            19 
      #define HTCLOSE             20 
      #define HTHELP              21 
      */ 

; Close window with titlebar click 
  If WM_NCHITTEST_Result in 2,3,8,9,20,21 ; in titlebar enclosed area - top of window 
    { 
    ;PostMessage, 0x112, 0xF060,,, ahk_id %WindowUnderMouseID% ; 0x112 = WM_SYSCOMMAND, 0xF060 = SC_CLOSE 
    ;PostMessage, 0x112, 0xF020,,, ahk_id %WindowUnderMouseID% ; 0x112 = WM_SYSCOMMAND, 0xF020 = SC_MINIMIZE
    WinMinimize, ahk_id %WindowUnderMouseID%
    Return 
    } 

; else send normal middle click 
  If GetKeyState("MButton", "P") ; The middle button is physically down 
    MouseClick, Middle, %ClickX%, %ClickY%,, Down 
  Else 
    MouseClick, Middle, %ClickX%, %ClickY% 
  Return

